Attribute VB_Name = "General"
Type OPENFILENAME
        lStructSize As Long
        hwndOwner As Long
        hInstance As Long
        lpstrFilter As String
        lpstrCustomFilter As String
        nMaxCustFilter As Long
        nFilterIndex As Long
        lpstrFile As String
        nMaxFile As Long
        lpstrFileTitle As String
        nMaxFileTitle As Long
        lpstrInitialDir As String
        lpstrTitle As String
        Flags As Long
        nFileOffset As Integer
        nFileExtension As Integer
        lpstrDefExt As String
        lCustData As Long
        lpfnHook As Long
        lpTemplateName As String
End Type

Type SHITEMID
     cb As Long
     abID As Byte
End Type

Type ITEMIDLIST
     mkid As SHITEMID
End Type

Type BROWSEINFO
     hOwner As Long
     pidlRoot As Long
     pszDisplayName As String
     lpszTitle As String
     ulFlags As Long
     lpfn As Long
     lParam As Long
     iImage As Long
End Type

Public Const NOERROR = 0
Public Const BIF_RETURNONLYFSDIRS = &H1
Public Const BIF_DONTGOBELOWDOMAIN = &H2
Public Const BIF_STATUSTEXT = &H4
Public Const BIF_RETURNFSANCESTORS = &H8
Public Const BIF_BROWSEFORCOMPUTER = &H1000
Public Const BIF_BROWSEFORPRINTER = &H2000
Public Const OFS_MAXPATHNAME = 128

Type OFSTRUCT
        cBytes As Byte
        fFixedDisk As Byte
        nErrCode As Integer
        Reserved1 As Integer
        Reserved2 As Integer
        szPathName(OFS_MAXPATHNAME) As Byte
End Type

Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal hwndOwner As Long, ByVal nFolder As Long, pidl As ITEMIDLIST) As Long
Declare Function SHBrowseForFolder Lib "shell32.dll" Alias "SHBrowseForFolderA" (lpBrowseInfo As BROWSEINFO) As Long
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function LoadLibraryEx Lib "kernel32" Alias "LoadLibraryExA" (ByVal lpLibFileName As String, ByVal hFile As Long, ByVal dwFlags As Long) As Long
Declare Function FindResource Lib "kernel32" Alias "FindResourceA" (ByVal hInstance As Long, ByVal lpName As String, ByVal lpType As String) As Long
Declare Function FindResourceEx Lib "kernel32" Alias "FindResourceExA" (ByVal hModule As Long, ByVal lpType As String, ByVal lpName As String, ByVal wLanguage As Long) As Long
Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
Declare Function FreeResource Lib "kernel32" (ByVal hResData As Long) As Long
Declare Function LockResource Lib "kernel32" (ByVal hResData As Long) As Long
Declare Function LoadResource Lib "kernel32" (ByVal hInstance As Long, ByVal hResInfo As Long) As Long
Const LOAD_LIBRARY_AS_DATAFILE = 2

Dim modulehandle&

Public OFSTRUCT1 As OFSTRUCT
Public OFSTRUCT2 As OFSTRUCT

'Questa Sub  simile a quella presente nel file setup1.bas del
'programma di setup di Vb.
'This Sub is similar to the one found in the file setup1.bas
'of the setup program of Vb.

' "Riempie" (in base alla percentuale) il controllo PictureBox
' e visualizza inoltre il valore percentuale corrispondente
' al "riempimento".
'
' In: [pic]: controllo PictureBox utilizzato per visualizzare
'            l'area di "riempimento".
'     [sngPercent]: percentuale dell'area da riempire.
'     [fBorderCase]: indica se la percentuale specificata 
'        un valore limite, ovvero esattamente 0% o 100%. A meno
'        che fBorderCase non sia True, i valori 0% e 100% verranno
'        considerati "prossimi" a tali valori limite e verranno
'        utilizzati i valori 1% e 99% in sostituzione.
'
' Note:  imposta la propriet AutoRedraw del controllo PictureBox
'        su True in modo che la barra di stato e il valore percentuale
'        possano essere ridisegnati automaticamente se necessario.

Sub UpdateStatus(Pic As PictureBox, ByVal sngPercent As Single, Optional ByVal fBorderCase)
    Dim strpercent As String
    Dim IntX As Integer
    Dim IntY As Integer
    Dim intWidth As Integer
    Dim intHeight As Integer

    
    'Per una corretta implementazione,  necessario uno sfondo bianco
    'e un qualsiasi colore di primo piano (in questo caso blu).
    Const colBackground = &HFFFFFF ' Bianco.
    Const colForeground = &H800000 ' Blu.

    Pic.ForeColor = colForeground
    Pic.BackColor = colBackground
    
    '
    'Formatta il valore percentuale e recupera gli attributi del testo.
    '
    Dim intPercent
    intPercent = Int(sngPercent + 0.5)
    strpercent = Format$(intPercent) & "%"
    intWidth = Pic.TextWidth(strpercent)
    intHeight = Pic.TextHeight(strpercent)

    '
    'Imposta intX e intY sulla posizione di inizio per visualizzare la percentuale.
    '
    IntX = Pic.Width / 2 - intWidth / 2
    IntY = Pic.Height / 2 - intHeight / 2

    '
    ' necessario disegnare una casella riempita con il colore di sfondo dei controlli
    'PictureBox per cancellare l'eventuale visualizzazione precedente.
    '
    Pic.DrawMode = 13 ' Copy Pen
    Pic.Line (IntX, IntY)-Step(intWidth, intHeight), Pic.BackColor, BF

    '
    'Torna alla posizione di scrittura centrale e scrive il testo.
    '
    Pic.CurrentX = IntX
    Pic.CurrentY = IntY
    Pic.Print strpercent

    '
    'Riempie la casella con il colore di primo piano fino alla percentuale desiderata.
    'Se la percentuale  0, riempie tutta la casella con il colore di sfondo in
    'modo da cancellare la visualizzazione precedente. Utilizza l'impostazione "Not XOR Pen"
    'in modo che il colore del testo diventi bianco quando viene "toccato" e che il colore
    'di sfondo diventi blu quando viene "toccato".
    '
    Pic.DrawMode = 10 ' Not XOR Pen
    If sngPercent > 0 Then
        Pic.Line (0, 0)-(Pic.Width * intPercent / 100, Pic.Height), Pic.ForeColor, BF
    Else
        Pic.Line (0, 0)-(Pic.Width, Pic.Height), Pic.BackColor, BF
    End If
    Pic.Refresh
End Sub

Public Function ApriFile(Hwnd As Long, hInstance As Long, sfilter As String, InitDir As String, Titolo As String, Flags As Long) As String
    Static Directory$
    Dim openfiles As OPENFILENAME
    Dim lreturn As Long
    openfiles.lStructSize = Len(openfiles)
    openfiles.hwndOwner = Hwnd
    openfiles.hInstance = hInstance
    openfiles.lpstrFilter = sfilter
    openfiles.nFilterIndex = 1
    openfiles.lpstrFile = String(257, 0)
    openfiles.nMaxFile = Len(openfiles.lpstrFile) - 1
    openfiles.lpstrFileTitle = openfiles.lpstrFile
    openfiles.nMaxFileTitle = openfiles.nMaxFile
    If Len(Directory) = 0 Then
    openfiles.lpstrInitialDir = InitDir
    Else
    openfiles.lpstrInitialDir = Directory
    End If
    openfiles.lpstrTitle = Titolo
    openfiles.Flags = Flags
    lreturn = GetOpenFileName(openfiles)
    If lreturn = 0 Then ApriFile = "Cancella" Else ApriFile = openfiles.lpstrFile
    Directory = openfiles.lpstrInitialDir
End Function

'Questa funzione estrae il nome del file dal path
'assegnato alla variabile specin.
'This code is used to extract the filename provided by
'the user in the variable specin.

Public Function ExtractName(specin As String) As String
   
Dim i As Integer
Dim specout As String
   
On Error Resume Next 'ignore any errors 'ignora gli errori
   
For i = Len(specin) To 1 Step -1
If Mid(specin, i, 1) = "\" Then
   specout = Mid(specin, i + 1)
   Exit For
End If
Next i

ExtractName = specout
'ritorna il nome del file estratto dal path
'returns the extracted filename from the path

End Function
Public Function BrowseFolder(Hwnd As Long, Titolo As String) As String

'Funzione per visualizzare La Dialog di Browsefolder
'Function that shows the Browsefolder dialog

Dim bi As BROWSEINFO
Dim rtn&, pidl&, path$, pos%, specin$, specout$

bi.hOwner = Hwnd 'centres the dialog on the screen
bi.lpszTitle = Titolo 'set the title text
bi.ulFlags = BIF_RETURNONLYFSDIRS 'the type of folder(s) to return
pidl& = SHBrowseForFolder(bi) 'show the dialog box
  
path = Space(512) 'sets the maximum characters
rtn = SHGetPathFromIDList(ByVal pidl&, ByVal path) 'gets the selected path

pos% = InStr(path, Chr$(0)) 'extracts the path from the string
specin = Left(path, pos - 1) 'sets the extracted path to SpecIn

If Right$(specin, 1) = "\" Then 'makes sure that "\" is at the end of the path
   specout = specin             'if so then, do nothing
Else                            'otherwise
   specout = specin + "\"       'add the "\" to the end of the path
End If

BrowseFolder = specout

End Function
Public Function CopyThisFile(Src As String, Dst As String, Animate As Animation, Pic As PictureBox) As Single
Static Buf$
Dim BTest!, FSize!
Dim Chunk%, F1%, F2%
Const BUFSIZE = 1024 'set the buffer size
'inizializza la dimensione del buffer

If Len(Dir(Dst)) Then
   Response = MsgBox(Dst + Chr(10) + Chr(10) + "Il File esiste. Sovrascrivere il file?", vbYesNo + vbQuestion)
   If Response = vbNo Then
      Exit Function
   Else
      Kill Dst
   End If
End If
 
On Error GoTo FileCopyError
F1 = FreeFile
Open Src For Binary As F1
F2 = FreeFile
Open Dst For Binary As F2
Visibile False
Animate.Play
DoEvents
FSize = LOF(F1)
BTest = FSize - LOF(F2)
Dim NPercent%
Do
If BTest < BUFSIZE Then
   Chunk = BTest
Else
   Chunk = BUFSIZE
End If
      
Buf = String(Chunk, " ")
Get F1, , Buf
Put F2, , Buf
BTest = FSize - LOF(F2)
Dim Fattore&
Fattore = (100 - Int(100 * BTest / FSize))
If Fattore <> NPercent Then
NPercent = Fattore
UpdateStatus Pic, Fattore
End If
Loop Until BTest = 0
Close F1
Close F2
Animate.Stop
Visibile True
CopyThisFile = FSize
UpdateStatus Pic, 0
Exit Function

FileCopyError:
Animate.Stop
Visibile True
MsgBox "Errore Di Copia!, Riprovare di nuovo..."
Close F1
Close F2
Exit Function
End Function
Public Sub Visibile(Acceso As Boolean)
If Acceso Then
CopyFile.Animation1.Visible = False
CopyFile.Browsefile.Visible = True
CopyFile.Browsedestination.Visible = True
CopyFile.Destinationpath.Visible = True
CopyFile.Filepath.Visible = True
Else
CopyFile.Animation1.Visible = True
CopyFile.Browsefile.Visible = False
CopyFile.Browsedestination.Visible = False
CopyFile.Destinationpath.Visible = False
CopyFile.Filepath.Visible = False
End If
End Sub

